      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

;**********************************************************************
;     include files
;**********************************************************************     
      include \Altra32\include\windows.inc
      include \Altra32\include\user32.inc
      include \Altra32\include\gdi32.inc
      include \Altra32\include\kernel32.inc
      include \Altra32\include\comdlg32.inc
      include \Altra32\include\Comctl32.inc

;**********************************************************************
; Local macros
;**********************************************************************
include \altra32\macros\macros.asm
include protos.inc

;**********************************************************************
; Public experns
;**********************************************************************
public hdriveA
public hdriveB
public hwriteimage


EXTERN hWnd:DWORD
EXTERN hInstance:DWORD
EXTERN hIcon:DWORD
EXTERN szAppName:PTR
EXTERN css:CONTROL_STRUCT
EXTERN hFont:DWORD
EXTERN hsector:DWORD
EXTERN hcreate:DWORD
EXTERN ReadDrive:BYTE
EXTERN hbyteread:DWORD
EXTERN hproggres:DWORD
EXTERN hback_brush:DWORD
EXTERN FileName:DWORD
EXTERN pOldProgressProc:DWORD

.data
hwriteimage     dd 0
mode            dd 0
hfilename       dd 0
hwrbrowse       dd 0
hrfilename      dd 0
hrbrowse        dd 0
hd2i            dd 0
hi2d            dd 0
hdriveA         dd 0
hdriveB         dd 0
hgroup3         dd 0
hgroup2         dd 0
hgroup1         dd 0
ThreadID        dd 0
hThread         dd 0

;FormatVolume
.code
;**********************************************************************
; This is the Main programs code area. all messages for this APP are
; recived here, or the main app.
;**********************************************************************
WinProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD


        .if uMsg == WM_CREATE
            mov [hFont],FUNC(CreateFont,13,5,0,0,FW_NORMAL,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_STROKE_PRECIS,CLIP_STROKE_PRECIS,DRAFT_QUALITY,FF_SWISS,txt,("Tahoma"));
            invoke CenterWindow,hWin

            mov css.ExStyle,     0
            mov css.Style,       WS_CHILD or WS_VISIBLE or PBS_SMOOTH
            mov css.lpText,      txt("Status")
            mov css.Xpos,        5
            mov css.Ypos,        5
            mov css.Xsize,       325
            mov css.Ysize,       40
            mov css.ControlType, CTRL_GROUPBOX
            mov css.ID,          -1 
            mov [hgroup1],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hgroup1,WM_SETFONT,hFont,0

            mov css.ExStyle,     0
            mov css.Style,       WS_CHILD or WS_VISIBLE
            mov css.lpText,      txt("Reading Sector: ")
            mov css.Xpos,        20
            mov css.Ypos,        20
            mov css.Xsize,       130
            mov css.Ysize,       20
            mov css.ControlType, CTRL_STATICBOX
            mov css.ID,          -1 
            mov [hsector],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hsector,WM_SETFONT,hFont,0

            mov css.ExStyle,     0
            mov css.Style,       WS_CHILD or WS_VISIBLE
            mov css.lpText,      txt("Bytes Read: ")
            mov css.Xpos,        180
            mov css.Ypos,        20
            mov css.Xsize,       130
            mov css.Ysize,       20
            mov css.ControlType, CTRL_STATICBOX
            mov css.ID,          -1 
            mov [hbyteread],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hbyteread,WM_SETFONT,hFont,0

            mov css.ExStyle,     0
            mov css.Style,       WS_CHILD or WS_VISIBLE or WS_GROUP
            mov css.lpText,      txt("Drive")
            mov css.Xpos,        5
            mov css.Ypos,        45
            mov css.Xsize,       100
            mov css.Ysize,       40
            mov css.ControlType, CTRL_GROUPBOX
            mov css.ID,          -1 
            mov [hgroup2],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hgroup2,WM_SETFONT,hFont,0

            mov css.ExStyle,     0
            mov css.Style,       WS_CHILD or WS_VISIBLE 
            mov css.lpText,      txt("A:")
            mov css.Xpos,        20
            mov css.Ypos,        60
            mov css.Xsize,       30
            mov css.Ysize,       20
            mov css.ControlType, CTRL_RADIOBOX
            mov css.ID,          DRIVE_A_SELECT 
            mov [hdriveA],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hdriveA,WM_SETFONT,hFont,0
            invoke SendMessage,hdriveA,BM_SETCHECK,BST_CHECKED,0

            mov css.ExStyle,     0
            mov css.Style,       WS_CHILD or WS_VISIBLE
            mov css.lpText,      txt("B:")
            mov css.Xpos,        60
            mov css.Ypos,        60
            mov css.Xsize,       30
            mov css.Ysize,       20
            mov css.ControlType, CTRL_RADIOBOX
            mov css.ID,          DRIVE_B_SELECT 
            mov [hdriveB],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hdriveB,WM_SETFONT,hFont,0

            mov css.ExStyle,     0
            mov css.Style,       WS_CHILD or WS_VISIBLE or WS_GROUP
            mov css.lpText,      txt("Mode")
            mov css.Xpos,        110
            mov css.Ypos,        45
            mov css.Xsize,       220
            mov css.Ysize,       40
            mov css.ControlType, CTRL_GROUPBOX
            mov css.ID,          -1 
            mov [hgroup3],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hgroup3,WM_SETFONT,hFont,0

            mov css.ExStyle,     0
            mov css.Style,       WS_CHILD or WS_VISIBLE 
            mov css.lpText,      txt("Floppy to Img file.")
            mov css.Xpos,        115
            mov css.Ypos,        60
            mov css.Xsize,       100
            mov css.Ysize,       20
            mov css.ControlType, CTRL_RADIOBOX
            mov css.ID,          FLOPPY_TO_IMG_FILE 
            mov [hd2i],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hd2i,WM_SETFONT,hFont,0
            invoke SendMessage,hd2i,BM_SETCHECK,BST_CHECKED,0

            mov css.ExStyle,     0
            mov css.Style,       WS_CHILD or WS_VISIBLE
            mov css.lpText,      txt("Img file to Floppy.")
            mov css.Xpos,        225
            mov css.Ypos,        60
            mov css.Xsize,       100
            mov css.Ysize,       20
            mov css.ControlType, CTRL_RADIOBOX
            mov css.ID,          IMG_FILE_TO_FLOPPY 
            mov [hi2d],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hi2d,WM_SETFONT,hFont,0

            mov css.ExStyle,     WS_EX_CLIENTEDGE
            mov css.Style,       WS_CHILD or WS_VISIBLE or ES_CENTER 
            mov css.lpText,      txt("Img Name and path.")
            mov css.Xpos,        5
            mov css.Ypos,        100
            mov css.Xsize,       290
            mov css.Ysize,       20
            mov css.ControlType, CTRL_EDITBOX
            mov css.ID,          WRITE_FILENAME 
            mov [hfilename],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hfilename,WM_SETFONT,hFont,0
            invoke EnableWindow,hfilename,FALSE

            mov css.ExStyle,     WS_EX_CLIENTEDGE
            mov css.Style,       WS_CHILD or WS_VISIBLE
            mov css.lpText,      txt("...")
            mov css.Xpos,        300
            mov css.Ypos,        100
            mov css.Xsize,       30
            mov css.Ysize,       20
            mov css.ControlType, CTRL_BUTTON
            mov css.ID,          BROWSE_WRITE_FILE 
            mov [hwrbrowse],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hwrbrowse,WM_SETFONT,hFont,0
            invoke EnableWindow,hwrbrowse,FALSE

            mov css.ExStyle,     WS_EX_CLIENTEDGE
            mov css.Style,       WS_CHILD or WS_VISIBLE or ES_CENTER 
            mov css.lpText,      txt("Img Filename Name and path.")
            mov css.Xpos,        5
            mov css.Ypos,        130
            mov css.Xsize,       290
            mov css.Ysize,       20
            mov css.ControlType, CTRL_EDITBOX
            mov css.ID,          READ_FILENAME 
            mov [hrfilename],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hrfilename,WM_SETFONT,hFont,0

            mov css.ExStyle,     WS_EX_CLIENTEDGE
            mov css.Style,       WS_CHILD or WS_VISIBLE
            mov css.lpText,      txt("...")
            mov css.Xpos,        300
            mov css.Ypos,        130
            mov css.Xsize,       30
            mov css.Ysize,       20
            mov css.ControlType, CTRL_BUTTON
            mov css.ID,          BROWSE_READ_FILE 
            mov [hrbrowse],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hrbrowse,WM_SETFONT,hFont,0

            mov css.ExStyle,     0
            mov css.Style,       WS_CHILD or WS_VISIBLE
            mov css.lpText,      txt("Create Image")
            mov css.Xpos,        100
            mov css.Ypos,        160
            mov css.Xsize,       150
            mov css.Ysize,       20
            mov css.ControlType, CTRL_BUTTON
            mov css.ID,          CREATE_IMAGE 
            mov [hcreate],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hcreate,WM_SETFONT,hFont,0

            mov css.ExStyle,     0
            mov css.Style,       WS_CHILD or WS_VISIBLE
            mov css.lpText,      txt("Write to Floppy")
            mov css.Xpos,        100
            mov css.Ypos,        160
            mov css.Xsize,       150
            mov css.Ysize,       20
            mov css.ControlType, CTRL_BUTTON
            mov css.ID,          WRITE_IMAGE 
            mov [hwriteimage],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hwriteimage,WM_SETFONT,hFont,0
            invoke ShowWindow,hwriteimage,SW_HIDE

            mov css.ExStyle,     0
            mov css.Style,       WS_CHILD or WS_VISIBLE or PBS_SMOOTH  
            mov css.lpText,      0
            mov css.Xpos,        5
            mov css.Ypos,        190
            mov css.Xsize,       325
            mov css.Ysize,       20
            mov css.ControlType, CTRL_PROGRESSBAR
            mov css.ID,          5000 
            mov [hproggres],FUNC(CreateControl,hWin,addr css)
            invoke SendMessage,hproggres,WM_SETFONT,hFont,0
            invoke SendMessage,hproggres,PBM_SETBARCOLOR,0,0CBC0FFh 
            invoke SendMessage,hproggres,PBM_SETBKCOLOR,0,0FAF0E6h
            invoke SetWindowLong,hproggres,GWL_WNDPROC,addr progress_proc
            mov [pOldProgressProc],eax

        .elseif uMsg == WM_PAINT


        .elseif uMsg == WM_COMMAND
                .if wParam == BROWSE_WRITE_FILE
                    invoke GetFileName,hWin,txt("Open File"),txt("Img files",0,"*.img")
                    .if FileName[0] != 0
                        invoke SetWindowText,hfilename,addr FileName
                    .endif                   
                .endif
                .if wParam == BROWSE_READ_FILE
                    invoke SetFileName,hWin,txt("Create File"),txt("Img files",0,"*.img")
                    .if FileName[0] != 0
                        invoke SetWindowText,hrfilename,addr FileName
                    .endif                   
                .endif
                .if wParam == CREATE_IMAGE
                    mov [hThread],FUNC(CreateThread,NULL,NULL,addr read_floppy_img,hWin,0,addr ThreadID) 
                    invoke CloseHandle,hThread
                    return 0
                .endif
                .if wParam == WRITE_IMAGE
                    mov [hThread],FUNC(CreateThread,NULL,NULL,addr write_floppy_img,hWin,0,addr ThreadID) 
                    invoke CloseHandle,hThread
                    return 0
                .endif
                .if wParam == DRIVE_A_SELECT
                    mov [ReadDrive],'A'
                .endif
                .if wParam == DRIVE_B_SELECT
                    mov [ReadDrive],'B'
                .endif
                .if wParam == FLOPPY_TO_IMG_FILE
                    mov [mode],FLOPPY_TO_IMG_FILE
                    invoke ShowWindow,hwriteimage,SW_HIDE
                    invoke ShowWindow,hcreate,SW_SHOW
                    invoke EnableWindow,hfilename,FALSE
                    invoke EnableWindow,hwrbrowse,FALSE
                    invoke EnableWindow,hrfilename,TRUE
                    invoke EnableWindow,hrbrowse,TRUE
                .endif
                .if wParam == IMG_FILE_TO_FLOPPY
                    mov [mode],IMG_FILE_TO_FLOPPY
                    invoke ShowWindow,hwriteimage,SW_SHOW
                    invoke ShowWindow,hcreate,SW_HIDE
                    invoke EnableWindow,hfilename,TRUE
                    invoke EnableWindow,hwrbrowse,TRUE
                    invoke EnableWindow,hrfilename,FALSE
                    invoke EnableWindow,hrbrowse,FALSE
                .endif
                return 0

        .elseif uMsg == WM_SIZE


        .elseif uMsg == WM_CLOSE
                invoke DestroyWindow,hd2i
                invoke DestroyWindow,hi2d
                invoke DestroyWindow,hdriveA
                invoke DestroyWindow,hdriveB
                invoke DestroyWindow,hgroup3
                invoke DestroyWindow,hgroup2
                invoke DestroyWindow,hgroup1
                invoke DestroyWindow,hproggres
                invoke DestroyWindow,hwriteimage
                invoke DestroyWindow,hfilename
                invoke DestroyWindow,hwrbrowse
                invoke DestroyWindow,hrfilename
                invoke DestroyWindow,hrbrowse
                invoke DestroyWindow,hsector
                invoke DestroyWindow,hbyteread
                invoke DestroyWindow,hcreate
                invoke DeleteObject,hFont
                invoke DestroyIcon,hIcon
                invoke DestroyWindow,hWin
                return 0

        .elseif uMsg == WM_DESTROY
                invoke PostQuitMessage,0
                return 0
        .endif
        invoke DefWindowProc,hWin,uMsg,wParam,lParam
        ret
WinProc endp

end

