      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

      include \Altra32\include\windows.inc
      include \Altra32\include\user32.inc
      include \Altra32\include\kernel32.inc
      include \Altra32\include\comdlg32.inc

include \altra32\macros\macros.asm

EXTERN hInstance      :DWORD
EXTERN FileName       :PTR


.data?
ofn            OPENFILENAME<>

.code
;*******************************************************************
;
;
;*******************************************************************
GetFileName proc hParent:DWORD,lpTitle:DWORD,lpFilter:DWORD

            mov ofn.lStructSize,        sizeof OPENFILENAME
            m2m ofn.hWndOwner,          hParent
            m2m ofn.hInstance,          hInstance
            m2m ofn.lpstrFilter,        lpFilter
            m2m ofn.lpstrFile,          offset FileName
            mov ofn.nMaxFile,           MAX_PATH*50
            m2m ofn.lpstrTitle,         lpTitle
            mov ofn.Flags,              OFN_EXPLORER or OFN_FILEMUSTEXIST or \
                                        OFN_LONGNAMES or OFN_ALLOWMULTISELECT
            invoke GetOpenFileName,addr ofn
            ret
GetFileName endp
;*******************************************************************
;
;
;*******************************************************************
SetFileName proc hParent:DWORD,lpTitle:DWORD,lpFilter:DWORD

            mov ofn.lStructSize,        sizeof OPENFILENAME
            m2m ofn.hWndOwner,          hParent
            m2m ofn.hInstance,          hInstance
            m2m ofn.lpstrFilter,        lpFilter
            m2m ofn.lpstrFile,          offset FileName
            mov ofn.nMaxFile,           MAX_PATH*50
            m2m ofn.lpstrTitle,         lpTitle
            mov ofn.Flags,              OFN_EXPLORER or OFN_LONGNAMES
            invoke GetOpenFileName,addr ofn
            ret
SetFileName endp

end
