      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

;**********************************************************************
;     library includes.
;**********************************************************************
       include \Altra32\include\windows.inc
       include \Altra32\include\user32.inc
       include \Altra32\include\kernel32.inc
       include \Altra32\include\gdi32.inc


;**********************************************************************
; Local macros
;**********************************************************************
include \altra32\macros\macros.asm
include protos.inc

extern hFont:DWORD
extern sector:DWORD
extern max_sectors:DWORD


public pOldProgressProc

.data
pOldProgressProc    dd 0
buffer              db 50 Dup(0)


.code
;***********************************************************************
; This function was created for the soul perpose of displaying the
; proggress in '%', sence I know of no other way of doing this
; this is what I came up with. It simply paints the back ground
; color (which erase's any numbers.) then sends control to the
; REAL controls PROC to do it's thing, then paints the % over
; all that.
;***********************************************************************
progress_proc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

              LOCAL hDC           :DWORD
              LOCAL hBrush        :DWORD
              LOCAL rect          :RECT
              LOCAL count         :DWORD
              LOCAL val           :DWORD
              

              .if uMsg == WM_PAINT
                  ;**************************************
                  ;* Get a DC and paint the background 
                  ;* color.
                  ;**************************************
                  mov [hDC],FUNC(GetDC,hWin)
                  invoke GetClientRect,hWin,addr rect
                  add [rect.top],2
                  add [rect.left],148
                  sub [rect.right],148
                  mov [hBrush],FUNC(CreateSolidBrush,0FAF0E6h)
                  invoke FillRect,hDC,addr rect,hBrush
                  invoke DeleteObject,hBrush
                  invoke ReleaseDC,hWin,hDC
                  ;******************************************
                  ;* Now send control to the REAL control's
                  ;* proc to do it's thing. so we don't have
                  ;* too.
                  ;******************************************
                  invoke CallWindowProc,pOldProgressProc,hWin,uMsg,wParam,lParam
                  ;******************************************
                  ;* Now get a DC again. and select the font 
                  ;* into it and set the background mode to
                  ;* TRANSPARENT for text painting.
                  ;******************************************
                  mov [hDC],FUNC(GetDC,hWin)
                  invoke SelectObject,hDC,hFont
                  invoke SetBkMode,hDC,TRANSPARENT
                  ;********************************************
                  ;* Now take max sectors, and divide this
                  ;* by 100, because max sectors is the whole.
                  ;* this should give us a number that is equal
                  ;* to 1%.
                  ;********************************************
                  mov eax,max_sectors
                  .if eax > 100
                      xor edx,edx
                      mov ecx,100
                      div ecx
                      ;****************************************
                      ;* Now as long as sector is higher then
                      ;* our 1% value, we divide sector by our
                      ;* 1% value to come up with how many 1%'s
                      ;* we have.
                      ;****************************************
                      .if eax < sector
                          xor edx,edx
                          mov ecx,eax
                          mov eax,[sector]
                          div ecx
                          dec eax
                      .else
                          mov eax,0
                      .endif
                      ;*****************************************
                      ;* The math never comes up even, so don't
                      ;* let the value go over 100%
                      ;*****************************************
                      .if eax > 100
                          mov eax,100
                      .endif
                  .endif
                  ;***************************************
                  ;* Now save this value and beging to
                  ;* to paint it in the proggress control.
                  ;* and wrap this all up and we are done.
                  ;***************************************
                  mov [val],eax
                  invoke dw2ac,val,addr buffer
                  invoke lstrcat,addr buffer,txt("%")
                  mov [count],FUNC(lstrlen,addr buffer)
                  invoke DrawText,hDC,addr buffer,count,addr rect,DT_CENTER                 
                  invoke ReleaseDC,hWin,hDC
                  return 0
              .endif

              invoke CallWindowProc,pOldProgressProc,hWin,uMsg,wParam,lParam
              ret
progress_proc endp


end


